Attribute VB_Name = "modRegUnreg"
'
' Copyright (C) 2000-2003 Christian Lemke
'
' Bei Fragen oder Bugs (Fehlern) wenden sich sich bitte an:
'
'   E-Mail: support@chlhp.de
'      WWW: http://www.chlhp.de
'
Option Explicit

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" _
  (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, _
    ByVal lpProcName As String) As Long
Private Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, _
   ByVal dwStackSize As Long, ByVal lpStartAddress As Long, ByVal lParameter As Long, _
   ByVal dwCreationFlags As Long, lpThreadID As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, _
    ByVal dwMilliseconds As Long) As Long
Private Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, _
    lpExitCode As Long) As Long
Private Declare Sub ExitThread Lib "kernel32" (ByVal dwExitCode As Long)
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long


    
Public Function RegUnReg(ByVal DLLname As String, register As Boolean) As Integer
On Error Resume Next
Dim lLib As Long                'enthlt den Handle (Zugriffsnummer) der DLL
Dim lpDLLEntryPoint As Long     'enthlt die Speicheradresse der aufzurufenden Funktion
Dim lpThreadID As Long          'Zeiger auf Thread (-identifizierer)
Dim lpExitCode As Long          'Exitcode von GetExitCodeThread
Dim mThread
Dim mresult
    
lLib = LoadLibrary(DLLname)     'Ldt die DLL (Datei) in den Speicherbereich des aufrufenden Prozesses
If lLib = 0 Then 'tritt z.B. auf, wenn die DLL (Datei) nicht existiert oder ungltig ist
    RegUnReg = Err.LastDllError 'gibt Fehlercode zurck
    Exit Function               'beendet Funktion
End If

'findet und speichert den DLL Einsprungspunkt, d.h. ermittelt die Speicheradresse
'der "DllRegisterServer" bzw. "DllUnregisterServer" Funktion (um die DLL zu
'Registrieren oder Deregistrieren).
If register = True Then 'DLL registrieren
    lpDLLEntryPoint = GetProcAddress(lLib, "DllRegisterServer")
 Else                   'DLL deregistrieren
    lpDLLEntryPoint = GetProcAddress(lLib, "DllUnregisterServer")
End If
If lpDLLEntryPoint = vbNull Then
    RegUnReg = Err.LastDllError 'gibt Fehlercode zurck
    FreeLibrary lLib            'gibt die Referenz (Handle) auf die geladene DLL frei
    Exit Function               'beendet Funktion
End If
    
'erstellt einen Thread, der die Funktion ausfhrt
mThread = CreateThread(ByVal 0, 0, ByVal lpDLLEntryPoint, ByVal 0, 0, lpThreadID)
If mThread = 0 Then
    RegUnReg = Err.LastDllError 'gibt Fehlercode zurck
    FreeLibrary lLib            'gibt die Referenz (Handle) auf die geladene DLL frei
    Exit Function               'beendet Funktion
End If
    
'benutzt WaitForSingleObject um den Rckkehrcode (Status) auszuwerten, wenn die
'Funktion erfolgreich beendet wurde bzw. nicht reagiert hat
mresult = WaitForSingleObject(mThread, 10000) '10000 ms
If mresult <> 0 Then
    RegUnReg = Err.LastDllError 'gibt Fehlercode zurck
    FreeLibrary lLib            'gibt die Referenz (Handle) auf die geladene DLL frei
    lpExitCode = GetExitCodeThread(mThread, lpExitCode) 'ermittelt Referenz des Exitcodes (Variable)
    ExitThread lpExitCode       'beendet Thread und gibt benutzte Resourcen frei
    Exit Function               'beendet Funktion
End If
    
CloseHandle mThread     'schliet Referenz (Handle) zum Thread
FreeLibrary lLib        'gibt die Referenz (Handle) auf die geladene DLL frei
RegUnReg = 0            '(De-) Registrierung erfolgreich abgeschlossen
End Function


